<?php

namespace Drupal\tacjs_domain\Form\Steps;

/**
 * Utility methods for the TacJS domain forms.
 */
trait DomainFormTrait {

  /**
   * {@inheritDoc}
   */
  protected function getConfig() {
    $config = parent::getConfig();
    $moduleOverrides = $this->getConfigModuleOverrides($config);
    if (!empty($moduleOverrides)) {
      $config->merge($moduleOverrides);
    }
    return $config;
  }

  /**
   * Get the moduleOverrides protected property value.
   *
   * @param \Drupal\Core\Config\Config $config
   *   The TacJS module configuration.
   *
   * @return mixed
   *   The overridden values.
   */
  protected function getConfigModuleOverrides($config) {
    $reflection = new \ReflectionClass($config);
    $property = $reflection->getProperty('moduleOverrides');
    $property->setAccessible(TRUE);
    return $property->getValue($config);
  }

}
